<?


////////////////////////////////////////////////////////
//
// correcting_article.php3 - Correcting mistakes in Articles
//                           in CoLi Database 
//                   
//   
//
////////////////////////////////////////////////////////
//
// Last Modified : 13.01.02
// Korrektur wird so gemacht:
//  --> 1 <-- Die erste Seite wird aufgerufen. 
//            Dort kann man die Signatur eingeben.
//
//  --> 2 <-- Dann suche ich nach articles.id 
//            Standart und formular ausgabe. Hier kann man schon die 
//            eintraege korrigieren. Die obere standart ausgabe dient 
//            dazu, dass man nachschauen kann was man zu korrigieren hat.
//
//  --> 3 <-- Nach dem id wird spaeter korrigiert! 
//            Ausgabe der standart ausgabe 
//            (also tabelle, ohne moeglichkeit zu korriegieren). 
// 
// 
//
// ---------------------------------------------------- 
// Correcting books in CoLi
//
// Author: Dainius Ramanauskas 
// Last Modified : 13.01.02
//
// See the file: bib_standard.inc,
//
// Functions :
// ===========
//   1. first_page()   
//   2. display_results()      
//   3. insert_records()       
//
////////////////////////////////////////////////////////

// include file
include ("/home/SG/dainius/php/bib_standard.inc");

define ( FIRST,0);
define ( SECOND,1);
define ( THIRD,3);


//-----------------------------------------------------------------------------
// Anfang der Funktionen
//-----------------------------------------------------------------------------


//---------------------------------------------------------
//
// --> 1 <-- Erste Seite wird aufgerufen, 
//           wo man die den suchbegriff eingeben kann
//
//-----------------------------------------------------------

function correcting_first_page ()
{
  global $PHP_SELF;
  
  printf ("<FORM method=\"post\" ACTION=\"%s?action=%d\">\n",$PHP_SELF, SECOND);
  
  print ("<br><center><h1> Artikel Korrektur </h1></center>");
  
  print ("<table align=center>");
  print (" <tr><td> <select name=In_where>   "
	 ."           <option> -- Bitte ID vom ARTIKEL eingeben ! -- "
	 ."         </select>                "
	 ." <input type=text  name=\"Find\"  ");  // $Find  
  // "Find" wird als globale variable definiert
  // "name = In_where ist" ist nicht mehr wichtig, da es so wieso nur
  // nach signatur gesucht wird.

  print ( "  size=15></td>       ");
  print ( "    <tr><td align=center>       "
	  ."   <input  type=\"submit\"     "
	  ."   value=\"Suchen\"></td>\n    ");
  print ("<BR>\n");
  print ("</table>");
  
  print ("</form>\n");
  
}

// ----------------------------------------------------------
//
// --> 2 <-- Die Resultate werden ausgegeben!!!!!!!!
//
// ----------------------------------------------------------

function correcting_display_results () {
  global $PHP_SELF;
  global $Find;   
  
  
  
  
  
  //
  // Suche nach 
  //             books_exemplar.Id
  //             books_exemplar.books_id  . 
  // Beide sind eindeutig!!
  //
  $query  = "select                                          "
     ."         id,                                          "
     ."         author,                                      "
     ."         editor,                                      "
     ."         title,                                       "
     ."         magazine,                                    "
     ."         type,                                        "
     ."         year_a,                                      "
     ."         keyword,                                     "
     ."         pages,                                       "
     ."         location,                                    "
     ."         bib                                          "
     ."      from                                            "
     ."         articles                                     "
     ."      where                                           "
     ."                  articles.id = \"$Find\"             " ;
     
  
  // Uberpruefe, ob der query richtig ist:
  $result = mysql_query($query)
     or die ("can't execute correcting_article.php3 -> query 2.1");
  
  
  // header fuer html-ausgabe:
  echo (" <caption><h1><center>Suchergebnis f&#252;r $Find : "
	."       </center></h1></caption>                    ");
  
  // hier werden rekursiv die daten ausgegeben:
  while ($row = mysql_fetch_row($result)) {
    
        
    // hier wird die tabelle ausgegeben
    echo ("<table align=center border=0 width=70%>");
    //echo ("<colgroup>");
    //  echo ("<col width=100>");
    //  echo ("<col width=300>");
    //echo ("</colgroup>");
    
    printf ("<tr bgcolor=#f1f49c >
                <td width=100> Artikel.Id    </td> 
                 <td width=300>           &nbsp;%s  </td>
                 </tr>\n", $row[0]);
    
    printf ("<tr bgcolor=#f1f49c >
                 <td width=100 > Author </td> 
                 <td width=300>&nbsp;%s</td>
              </tr>\n", $row[1]);
      
    printf ("<tr bgcolor=#f1f49c>
                 <td width=100> Editor </td> 
                 <td width=300> &nbsp; %s   </td> 
              </tr>", $row[2]);
    
    printf ("<tr bgcolor=#d6f98a >
               <td width=100><strong> Titel </strong> </td> 
               <td width=300><strong> &nbsp;%s  </strong>   </td>
            </tr>\n", $row[3]);
    
    printf ("<tr bgcolor=#f1f49c >
               <td width=100 > Zeitschrift </td> 
               <td width=300>&nbsp;%s       </td>
            </tr>\n", $row[4]);
    
    printf ("<tr bgcolor=#f1f49c >
                <td width=100 > Typ </td> 
                <td width=300> &nbsp;%s       </td>
            </tr>\n", $row[5]);

    printf ("<tr bgcolor=#f1f49c >
                <td  width=100> Jahr </td> 
                <td width=300> &nbsp;%s                     </td>
            </tr>\n", $row[6]);
    printf ("<tr bgcolor=#f1f49c >
                <td width=100 > Schl&uuml;sselwort </td> 
                <td width=300> &nbsp;%s         </td>
            </tr>\n", $row[7]);

    printf ("<tr bgcolor=#f1f49c >
                <td width=100 > Seiten </td> 
                <td width=300> &nbsp;%s                   </td>
            </tr>\n", $row[8]);

    printf ("<tr bgcolor=#f1f49c >
                <td width=100 > Standort  </td> 
                <td width=300> &nbsp;%s          </td>
            </tr>\n", $row[9]);

    printf ("<tr bgcolor=#f1f49c >
                <td width=100 > Bibliothek </td> 
                <td width=300> &nbsp;%s              </td>
            </tr>\n", $row[10]);

     
    // Hier wird die globale Variable fuer Books_exemplar.id definiert.
    // Die bruacht man um in Tabelle Books.exemplar zu korrigieren. 
    // Es koennen ja mehrere exemplare auftreten. Es werden immer
    // die gleichen stamm dateien angezeigt, aber nicht die gleichen 
    // exemplar dateien. 
    //    $Books_Exemplar_Id = $row[16];


    echo ("</table><p><p><p>");
    

    //-----------------------------------------------
    // --> 2.2 <--Die Tabelle zu korrektur wird ausgegeben
    //----------------------------------------------
        
    printf ("<FORM  method=\"post\" ACTION=\"%s?action=%d\">\n",
	    $PHP_SELF,THIRD);

    echo ("<font size=+7 color=red><center> Korrektur  : "
	  ."       </center></font>                    ");
    
    printf ("<table>");
    printf (" <tr><td>Artikel_Id &nbsp;</td> 
           <td> <select name=Article_Id>
           <option> $row[0]
           </select>
           </td>");
    

    printf (" <tr><td>Author ( NACHNAME, VORNAME; NACHN, VORN; )&nbsp;</td> 
           <td> <input type=text  name=Author
                          value=\"$row[1]\" size=255 maxlength=255></td>");  
 
 
    printf (" <tr><td>Editor &nbsp;</td> 
           <td> <input type=text  name=Editor
                           value=\"$row[2]\" size=225 maxlength=255></td>");

    printf (" <tr><td>Titel &nbsp;</td> 
           <td> <input type=text  name=Title
                           value=\"$row[3]\"size=255 maxlength=255></td>");

    printf (" <tr><td>Zeitschrift &nbsp;</td> 
           <td> <input type=text  name=Magazine
                value=\"$row[4]\"size=50 maxlength=50></td>");
           
    printf (" <tr> <td>Typ &nbsp;</td> 
           <td> <input type=text  name=Type
                value=\"$row[5]\" size=50 maxlength=50></td>");
 
    printf (" <tr><td>Jahr &nbsp;</td> 
           <td> <input type=text  name=Year
                   value=\"$row[6]\" size=4 maxlength=4></td>");

printf (" <tr><td>Schl&uuml;sselwort &nbsp;</td> 
           <td> <input type=text  name=Keyword
                   value=\"$row[7]\" size=50 maxlength=255></td>");

printf (" <tr><td>Seiten &nbsp;</td> 
           <td> <input type=text  name=Pages
                   value=\"$row[8]\" size=50 maxlength=50></td>");

printf (" <tr><td>Standort &nbsp;</td> 
           <td> <input type=text  name=Location
                   value=\"$row[9]\" size=50 maxlength=50></td>");

printf (" <tr><td>Bibliothek &nbsp;</td> 
           <td> <input type=text  name=Bib
                   value=\"$row[10]\"size=20 maxlength=20></td>");


 printf ("<tr><td><input  type=submit  value=Korrigieren></td>\n");
 printf ("<BR>\n");
 printf ("</table>");
 
 printf ("</form>\n");

 

 

   } 
 
 
}




//-----------------------------------------------------------------------------
// --> 3 <-- Korrigierte Daten werden zuruecke geschrieben !! VORSICHTIG!
//
//           ES WERDEN ALLE DATEN NEU IN DIE DATENBANK REINGESCHRIEBEN !
//
//-----------------------------------------------------------------------------

function correcting_insert_records () {
  global $PHP_SELF,$Find;
  global
   
    $Article_Id,              // ist die Id von books!! 
    $Author,
    $Editor,
    $Title,
    $Magazine,
    $Type,
    $Year,
    $Keyword,
    $Pages,
    $Location,
    $Bib ;


  // definiere array
  $array_for_global  =array(
			    $Article_Id,        // Wird nicht benutzt -- 0--
			    $Author,                        // -- 1 --
			    $Editor,                        // -- 2 --
			    $Title,                         // -- 3 --
			    $Magazine,                      // -- 4 --
			    $Type,                          // -- 5 --
			    $Year,                          // -- 6 --
			    $Keyword,                       // -- 7 --
			    $Pages,                         // -- 8 --
			    $Location,                      // -- 9 --
			    $Bib  );                        // -- 10 --
  
  $list_table_names = array (
			     "id",                         // -- 0 --
			     "author",                     // -- 1 --
			     "editor",                     // -- 2 --
			     "title",                      // -- 3 --
			     "magazine",                   // -- 4 --
			     "type",                       // -- 5 --
			     "year_a",                     // -- 6 --
			     "keyword",                    // -- 7 --
			     "pages",                      // -- 8 --
			     "location",                   // -- 9 --
			     "bib"         );              // -- 10 --
			   
    
  
  // ersetze die werte in der ARTICLES tabelle! 
  // Benutze die $Article_Id !!

  //echo "$Books_Id<BR>";

  for ($i = 1;$i<=10;$i++)
    {
      
      $query1="update articles "
	 . "   set $list_table_names[$i] = '$array_for_global[$i]'"
	 . "   where id='$Article_Id'                                 ";
      
      // nachfrage ob alles glatt gegangen ist?
      if (!($result = mysql_query($query1)))
	{
	  print("errno:" . mysql_errno());
	  print("error:" . mysql_error());
	  echo "Books korrektur fehlgeschlagen<BR>";
	}
      
    }

  //
  // DIE TABELLE WIRD NOCH MAL AUSGEGEBEN
  //
  $query  = "select                                          "
     ."         id,                                          "
     ."         author,                                      "
     ."         editor,                                      "
     ."         title,                                       "
     ."         magazine,                                    "
     ."         type,                                        "
     ."         year_a,                                      "
     ."         keyword,                                     "
     ."         pages,                                       "
     ."         location,                                    "
     ."         bib                                          "
     ."      from                                            "
     ."         articles                                     "
     ."      where                                           "
     ."                  articles.id = \"$Article_Id\"             " ;
     
  
  
  $result = mysql_query($query)
     or die ("can't execute query 3 in correcting_article.php3");
  
  echo (" <caption><h1><center>Richtig Korrigiert ??? : "
	."       </center></h1></caption>                    ");
  
  
  while ($row = mysql_fetch_row($result)) {
    
    // hier wird die tabelle ausgegeben
    echo ("<table align=center border=0 width=70%>");
    //echo ("<colgroup>");
    //  echo ("<col width=100>");
    //  echo ("<col width=300>");
    //echo ("</colgroup>");
    
        printf ("<tr bgcolor=#f1f49c >
                <td width=100> Artikel.Id    </td> 
                 <td width=300>           &nbsp;%s  </td>
                 </tr>\n", $row[0]);
    
    printf ("<tr bgcolor=#f1f49c >
                 <td width=100 > Author </td> 
                 <td width=300>&nbsp;%s</td>
              </tr>\n", $row[1]);
      
    printf ("<tr bgcolor=#f1f49c>
                 <td width=100> Editor </td> 
                 <td width=300> &nbsp; %s   </td> 
              </tr>", $row[2]);
    
    printf ("<tr bgcolor=#d6f98a >
               <td width=100><strong> Titel </strong> </td> 
               <td width=300><strong> &nbsp;%s  </strong>   </td>
            </tr>\n", $row[3]);
    
    printf ("<tr bgcolor=#f1f49c >
               <td width=100 > Zeitschrift </td> 
               <td width=300>&nbsp;%s       </td>
            </tr>\n", $row[4]);
    
    printf ("<tr bgcolor=#f1f49c >
                <td width=100 > Typ </td> 
                <td width=300> &nbsp;%s       </td>
            </tr>\n", $row[5]);

    printf ("<tr bgcolor=#f1f49c >
                <td  width=100> Jahr </td> 
                <td width=300> &nbsp;%s                     </td>
            </tr>\n", $row[6]);
    printf ("<tr bgcolor=#f1f49c >
                <td width=100 > Schl&uuml;sselwort </td> 
                <td width=300> &nbsp;%s         </td>
            </tr>\n", $row[7]);

    printf ("<tr bgcolor=#f1f49c >
                <td width=100 > Seiten </td> 
                <td width=300> &nbsp;%s                   </td>
            </tr>\n", $row[8]);

    printf ("<tr bgcolor=#f1f49c >
                <td width=100 > Standort  </td> 
                <td width=300> &nbsp;%s          </td>
            </tr>\n", $row[9]);

    printf ("<tr bgcolor=#f1f49c >
                <td width=100 > Bibliothek </td> 
                <td width=300> &nbsp;%s              </td>
            </tr>\n", $row[10]);
    
    
    echo ("</table><p><p><p>");
  }
 

 
} // -- ENDE DER INSERT_RECORD --

//
// Ende der Funktionen 
// ====================
//
/////////////////////////////////////////////////////////////////////////////// 

$titel = " Bibliothek Computerlinguistik ";
$color = "black";
html_begin($titel,$titel,$color);
link_to_main_page ();
bib_adm_connect()
     or die ("can't connect to server");

if (empty($action))
     $action = FIRST;
     
switch ($action)
{
 case FIRST:
   correcting_first_page ();
   break;
 case SECOND:
   correcting_display_results ();
   break;
 case THIRD:
   correcting_insert_records ();
   break;

 default:
   die("unknown action code ($action)");
}
link_to_main_page ();
html_end ();
?>
