<?

////////////////////////////////////////////////////////
//
// books_look.php3 - Find books for all users
//                   in Computerlinguistik
//
////////////////////////////////////////////////////////
//
// Find books in Computerlinguistik 
//
// Author: Dainius Ramanauskas 
// Last Modified : 31.12.00
//
// See the file: bib_standard.inc,
//
////////////////////////////////////////////////////////



include ("/home/SG/dainius/php/bib_standard.inc");

define ( FIRST,0);
define ( SECOND,1);
//define ( DEL_BOOKS,2);

///////////////////////////////////////////////////////
//
// Anfang der Funktionen
//
///////////////////////////////////////////////////////

//
// Erste Seite wird aufgerufen
//

function first_page ()
{
global $PHP_SELF;

printf ("<FORM  method=\"post\" ACTION=\"%s?action=%d\">\n",$PHP_SELF, SECOND);  
print ("<br><center><h1>B&uuml;cher Suchen</h1></center>");

// -----------------------------
//  1. Erste abfrage Zeile:
// ============================
//
//          -> an der 1 stelle steht in welche tabelle wird gesucht
//                                    ( wird als  variable "$Table_1" zugewiesen)
//          -> an der 2 stelle steht das suchwort             
//                                    ( wird als  variable "$Find_1" zugewiesen )
//          -> an der 3 stelle steht die verknupfung OR/AND
//                                    ( wird als  variable "$Link_1" zugewiesen )
// ------------------------------
//

// Fange mit der Tabelle an
 print ("<table align=center>");


 // Form fuer auswahl wo gesucht werden soll
 print ("
<tr>
  <td> 
    <select name=Table_1>
                 <option> Titel
                 <option> Author
                 <option> Signatur
                 <option> Editor
                 <option> Standort
    </select>
              
    <input type=text  name=\"Find_1\" value=\"\" size=15>
 
    <select name=Link_1>
        <option> AND
        <option> OR
    </select>
  </td>
</tr>
              
  ");

 // Zeilenumbruch
 print ("<BR>\n");
 
 
// -----------------------------
//  2. Zweites abfrage formular
// ------------------------------

 print ("
<tr>
  <td> 
    <select name=Table_2>
                <option> Author
                <option> Titel
                <option> Signatur
                <option> Editor
                <option> Standort
    </select>
                      
                            
   <input type=text  name=\"Find_2\" value=\"\" size=15>
 
   <select name=Link_2>
           <option> AND
           <option> OR
   </select>

   
  </td>
</tr>  
 ");
 
 // Zeilenumbruch
 print ("<BR>\n");
 
         
// -----------------------------
//  3. Drittes abfrage formular
// ------------------------------



print ("
<tr>
  <td> 

    <select name=Table_3>
                <option> Titel
                <option> Author
                <option> Signatur
                <option> Editor
                <option> Standort
    </select>
                            
   <input type=text  name=\"Find_3\" value=\"\" size=15>
 
   
   </select>

  </td>
</tr>
              
 ");  


// ---------------------------
//  4. Der Knopf zum suchen
// ----------------------


 print ("<tr><td align=center>
          <input  type=\"submit\" 
          value=\"Suchen\"></td></td>\n");

 // Zeilenumbruch
 print ("<BR>\n");
 
 // Ende der Tabelle 
 print ("</table>");
 
 // Das Ende der Form
 print ("</form>\n");
 
}

//
// Die Resultate werden ausgegeben!!!!!!!!
//

function display_results ()

{
  global $PHP_SELF;

  // Die Tabellen wo gesucht wird
  global $Table_1, $Table_2, $Table_3;

  //  $Table = $Table_1;

  // das wort das gesucht wird 
  global $Find_1, $Find_2, $Find_3;          

  // Die Verknuepfung zwischen den Woertern
  global $Link_1,$Link_2;
  
  // original  $Find
  // ist jetzt $find_orig
  $find_orig = $Find_1;

  // Definiere leeres String
  $leer = "";

  // ---------------------------------------------
  //  2.1 Erste Abfrage Schleife fuer $Find_1 :
  // ---------------------------------------------

  // Wenn eingabefelder leer --> fehler!
  if ($Find_1 == $leer && $Find_2 == $leer && $Find_3 == $leer){
      
      echo "<font color=red><h1>Sie haben nichts eingegeben!<BR>";
      
    }

  // Nur erstes feld ist belegt!
  elseif($Find_1 != $leer && $Find_2 == $leer && $Find_3 == $leer) {
    
    //
    // Hier werden die Variablen:
    //        - $Table_1
    //        - $Find_1
    // festgelegt 
    //
    if      ($Table_1 == Titel)
      {
	$Table_1 = "books.title";
	$Find_1     = "'%$Find_1%'";
      }
    
    elseif  ($Table_1 == Author)
      {
	$Table_1 = "books.author";
	$Find_1     = "'%$Find_1%'";
      }
    
    elseif  ($Table_1 == Signatur)
      {  
	$Table_1 = "books_exemplar.coli_id";
	$Find_1     = "'$Find_1'";
      } 
    elseif  ($Table_1 == Standort)
      {  
	$Table_1 = "books_exemplar.bib_location";
	$Find_1     = "'%$Find_1%'";
      }
    else
      {
	$Table_1 = "books.editor";
	$Find_1     = "'%$Find_1%'";
      }
      
            
      // hier wird gesucht nach:
      //       authoren, editoren, titeln, coli_id, bib_location
      
      
      
      $query  = "select 
                    books.*,
                    books_exemplar.coli_id, 
                    books_exemplar.bib_location,
                    books_exemplar.borrowed 
                    from books, 
                    books_exemplar 
            where
  
                   ( 
                      $Table_1 like $Find_1
                      AND 
                      books.id = books_exemplar.books_id
                   ) 
             ";
    }

  //----------------------------------------------------------
  // 2.2 Wenn 1 und 2 eingabefelder belegt sind
  //---------------------------------------------------------

  elseif ($Find_1 != $leer && 
          $Find_2 != $leer && 
          $Find_3 == $leer)    {
    
    //
    // Festlegung der Variablen 
    //  - $Find_1    
    //  - $Table_1
    //
    if      ($Table_1 == Titel)
      {
	$Table_1 = "books.title";
	$Find_1     = "'%$Find_1%'";
      }
    
    elseif  ($Table_1 == Author)
      {
	$Table_1 = "books.author";
	$Find_1     = "'%$Find_1%'";
      }
    
    elseif  ($Table_1 == Signatur)
      {  
	  $Table_1 = "books_exemplar.coli_id";
	  $Find_1     = "'$Find_1'";
      } 
    elseif  ($Table_1 == Standort)
      {  
	$Table_1 = "books_exemplar.bib_location";
	$Find_1     = "'%$Find_1%'";
      }
    else
      {
	$Table_1 = "books.editor";
	$Find_1     = "'%$Find_1%'";
      }

    //
    // Festlegung der Variablen 
    //  - $Find_2    
    //  - $Table_2
    //
    if      ($Table_2 == Titel)
      {
	$Table_2 = "books.title";
	$Find_2     = "'%$Find_2%'";
      }
    
    elseif  ($Table_2 == Author)
      {
	$Table_2 = "books.author";
	$Find_2     = "'%$Find_2%'";
      }
    
    elseif  ($Table_2 == Signatur)
      {  
	  $Table_2 = "books_exemplar.coli_id";
	  $Find_2     = "'$Find_2'";
      } 
    elseif  ($Table_2 == Standort)
      {  
	$Table_2 = "books_exemplar.bib_location";
	$Find_2     = "'%$Find_2%'";
      }
    else
      {
	$Table_2 = "books.editor";
	$Find_2     = "'%$Find_2%'";
      }

    
      
      
      // hier wird gesucht nach:
      //       authoren, editoren, titeln, coli_id, bib_location
      
      
      
    $query  = "
            select 
                    books.*,
                    books_exemplar.coli_id, 
                    books_exemplar.bib_location,
                    books_exemplar.borrowed 
                    from books, 
                    books_exemplar 
            where
  
                   ( 
                      $Table_1 like $Find_1
                      AND 
                      books.id = books_exemplar.books_id
                   ) 
            $Link_1
                  ( 
                      $Table_2 like $Find_2
                      AND 
                      books.id = books_exemplar.books_id
                   ) 

             ";



  }
 

  // -------------------------------------------------------------------------
  // 2.3 Wenn alle Felder belegt sind 
  // -------------------------------------------------------------------------
  else    {
    
    //
    // Festlegung der Variablen 
    //  - $Find_1    
    //  - $Table_1
    //
    if      ($Table_1 == Titel)
      {
	$Table_1 = "books.title";
	$Find_1     = "'%$Find_1%'";
      }
    
    elseif  ($Table_1 == Author)
      {
	$Table_1 = "books.author";
	$Find_1     = "'%$Find_1%'";
      }
    
    elseif  ($Table_1 == Signatur)
      {  
	  $Table_1 = "books_exemplar.coli_id";
	  $Find_1     = "'$Find_1'";
      } 
    elseif  ($Table_1 == Standort)
      {  
	$Table_1 = "books_exemplar.bib_location";
	$Find_1     = "'%$Find_1%'";
      }
    else
      {
	$Table_1 = "books.editor";
	$Find_1     = "'%$Find_1%'";
      }

    //
    // Festlegung der Variablen 
    //  - $Find_2    
    //  - $Table_2
    //
    if      ($Table_2 == Titel)
      {
	$Table_2 = "books.title";
	$Find_2     = "'%$Find_2%'";
      }
    
    elseif  ($Table_2 == Author)
      {
	$Table_2 = "books.author";
	$Find_2     = "'%$Find_2%'";
      }
    
    elseif  ($Table_2 == Signatur)
      {  
	  $Table_2 = "books_exemplar.coli_id";
	  $Find_2     = "'$Find_2'";
      } 
    elseif  ($Table_2 == Standort)
      {  
	$Table_2 = "books_exemplar.bib_location";
	$Find_2     = "'%$Find_2%'";
      }
    else
      {
	$Table_2 = "books.editor";
	$Find_2     = "'%$Find_2%'";
      }

    //
    // Festlegung der Variablen 
    //  - $Find_3    
    //  - $Table_3
    //
    if      ($Table_3 == Titel)
      {
	$Table_3 = "books.title";
	$Find_3     = "'%$Find_3%'";
      }
    
    elseif  ($Table_3 == Author)
      {
	$Table_3 = "books.author";
	$Find_3     = "'%$Find_3%'";
      }
    
    elseif  ($Table_3 == Signatur)
      {  
	  $Table_3 = "books_exemplar.coli_id";
	  $Find_3     = "'$Find_3'";
      } 
    elseif  ($Table_3 == Standort)
      {  
	$Table_3 = "books_exemplar.bib_location";
	$Find_3     = "'%$Find_3%'";
      }
    else
      {
	$Table_3 = "books.editor";
	$Find_3     = "'%$Find_3%'";
      }

    
      
      
      // hier wird gesucht nach:
      //       authoren, editoren, titeln, coli_id, bib_location
      
      
      
    $query  = "
            select 
                    books.*,
                    books_exemplar.coli_id, 
                    books_exemplar.bib_location,
                    books_exemplar.borrowed 
                    from books, 
                    books_exemplar 
            where
  
                   ( 
                      $Table_1 like $Find_1
                      AND 
                      books.id = books_exemplar.books_id
                   ) 
            $Link_1
                  ( 
                      $Table_2 like $Find_2
                      AND 
                      books.id = books_exemplar.books_id
                   ) 
            $Link_2
                  ( 
                      $Table_3 like $Find_3
                      AND 
                      books.id = books_exemplar.books_id
                   ) 

             ";



  }
/*
OR

   (
      books.editor like '%$s_schlag%' 
      AND 
      books.id = books_exemplar.books_id
   ) 

OR 

   (
     books.title like '%$s_schlag%' 
     AND 
     books.id = books_exemplar.books_id
   ) 


OR 

   (
     books_exemplar.coli_id like '$s_schlag' 
     AND 
     books_exemplar.books_id = books.id
   )
"; // unbedingt klammer setzen!
*/    




/*************************

// wird nach coli_id gesucht  ??    
    . "OR"
    . " (books_exemplar.coli_id like"
    . "'%"
    . $s_schlag
    . "%'"
    . "AND"
    . " books.id = books_exemplar.books_id)"
// wird nach isbn gesucht  ??   
    . "OR"
    . " (books.isbn like"
    . "'%"
    . $s_schlag
    . "%'"
    . "AND"
    . " books.id = books_exemplar.books_id)";
    
***************************/

$result = mysql_query($query)
	or die ("can't execute query 1");

echo ("<caption><h1><center>Suchergebnis f&#252;r $find_orig :
       </center></h1></caption>");

 // Die zahl der treffer: 
 $menge = mysql_num_rows($result);

// Die zahl der treffer wird ausgegeben:
 if ($menge > 0)
   printf ("Die Zahl der gefundenen Buecher : %d\n", $menge);
 else
   print ("<font color=red><h1><center>Leider keine treffer<p></font>");

 while ($row = mysql_fetch_row($result)) 
   {
     
    // wird nachgeschaut, ob buch ausgeliehen ist oder nicht.
    // wenn 0 dann --> vorhanden, wenn 1 dann ausgeliehen
     $num_from_table=$row[16];
     $is_num=0;
     if ($num_from_table==$is_num)
       {
	 $print_to="Vorhanden";  // wird Vorhanden ausgegeben
       }
     else 
       {
	 $print_to="Ausgeliehen bis $row[16]"; // wird das datum ausgeliehen
       }

    // hier wird die tabelle ausgegeben
     echo ("<table align=center border=0 width=70%>");
     //echo ("<colgroup>");
     //  echo ("<col width=100>");
     //  echo ("<col width=300>");
     //echo ("</colgroup>");

     printf ("<tr bgcolor=#f1f49c >
               <td width=100> Id    </td> 
               <td width=300>           &nbsp;%s  </td>
             </tr>\n", $row[0]);
    
     printf ("<tr bgcolor=#f1f49c >
               <td width=100 > Author </td> 
               <td width=300>&nbsp;%s</td>
            </tr>\n", $row[1]);
    
     printf ("<tr bgcolor=#f1f49c>
               <td width=100> Editor </td> 
               <td width=300> &nbsp; %s   </td> 
            </tr>", $row[2]);
    
     printf ("<tr bgcolor=#d6f98a>
               <td width=100><h2><strong> Titel </strong> </td> 
               <td width=300><h2><strong> &nbsp;%s  </strong>   </td>
            </tr>\n", $row[3]);
    
     printf ("<tr bgcolor=#f1f49c >
               <td width=100 > Typ </td> 
               <td width=300>&nbsp;%s       </td>
            </tr>\n", $row[4]);
    
     printf ("<tr bgcolor=#f1f49c >
                <td width=100 > Jahr </td> 
                <td width=300> &nbsp;%s       </td>
            </tr>\n", $row[5]);

     printf ("<tr bgcolor=#f1f49c >
                <td  width=100> Schl&uuml;sselwort </td> 
                <td width=300> &nbsp;%s                     </td>
            </tr>\n", $row[6]);
     printf ("<tr bgcolor=#f1f49c >
                <td width=100 > Series </td> 
                <td width=300> &nbsp;%s         </td>
            </tr>\n", $row[7]);

     printf ("<tr bgcolor=#f1f49c >
                <td width=100 > K&ouml;rperschaft </td> 
                <td width=300> &nbsp;%s                   </td>
            </tr>\n", $row[8]);

     printf ("<tr bgcolor=#f1f49c >
                <td width=100 > Verlag  </td> 
                <td width=300> &nbsp;%s          </td>
            </tr>\n", $row[9]);

     printf ("<tr bgcolor=#f1f49c >
                <td width=100 > Verlags Ort </td> 
                <td width=300> &nbsp;%s              </td>
            </tr>\n", $row[10]);

     printf ("<tr bgcolor=#f1f49c >
                <td width=100 > Bibliothek </td> 
                <td width=300> &nbsp;%s            </td>
            </tr>\n", $row[11]);


     printf ("<tr bgcolor=#f1f49c >
                <td width=100 > ISBN </td> 
                <td width=300> &nbsp;%s       </td>
            </tr>\n", $row[12]);

     printf ("<tr bgcolor=#ddddff >
                <td width=100 > Standort in Bib </td> 
                <td width=300> &nbsp;%s                  </td>
            </tr>\n", $row[15]);

     printf ("<tr bgcolor=#ddddff >
                <td width=100 >Author Abk. </td> 
                <td width=300> &nbsp;%s          </td>
            </tr>\n", $row[ 13 ]);

     printf ("<tr bgcolor=#ddddff >
                <td width=100 >Signatur </td> 
                <td width=300> &nbsp;%s          </td>
            </tr>\n", $row[14]);


     printf ("<tr bgcolor=#cccccc >
                <td width=100 > Status </td> 
                <td width=300> &nbsp;%s              </td>
            </tr>\n", $print_to);



    echo ("</table><p><p><p>");
  }
//echo ("/table");
 }
/*******************************************
// Tabelle ausgeben
echo ("<caption><h1>Suchergebnis f&#252;r $s_schlag :</h1></caption>");
echo ("<table border=2 bordercolor=#00FFFF>");
//echo ("<caption><h1>Suchergebnis f&#252;r $s_schlag </h1></caption>");

while ($row = mysql_fetch_row($result)) 
  {
	print ("<TR>\n");                            // ROWS!!
	for ($i=0; $i < mysql_num_fields($result); $i++)
 	{
		printf("<TD>%s</TD>\n", htmlspecialchars ($row[$i]));
	}
	print("</TR>\n");	

  }
mysql_free_result($result);

echo "</table>";
 }
*********************************************/   

//-------------------------------
// Ende der Funktionen
// -----------------------------

$titel = " Bibliothek Computerlinguistik ";
$color = "black";
html_begin($titel,$titel,$color);
//link_to_main_page ();
bib_connect()
     or die ("can't connect to server");

if (empty($action))
     $action = FIRST;
     
switch ($action)
{
 case FIRST:
   first_page ();
   break;
 case SECOND:
   display_results ();
   break;

 default:
   die("unknown action code ($action)");
}
//link_to_main_page ();
html_end ();
?>
