#!/usr/bin/perl -w 

###############################################################################
#                                                                             #
# booksDB_2_MPIformat.perl - formatiert die ausgelesene daten von typischen   #
#                            mysql format in IBIS spezifischen um.            #
#                                                                             #
###############################################################################
# Ablauf:                                                                     #
#          der file muss in mysql format vorliegen.                           #
#          Eingabe file muss eine bestimmte name haben. Siehe unten.          #
#          Ausgabe file hat auch einen namen. Siehe unten.                    #
#          Es wird ein file genommen, und der endfile erzeugt.                #
#          Details kann man von den einzelnschritten herausnehmen.            #
#                                                                             #
###############################################################################


# ----------------------
# Letzte Aenderung 9.9.01:
# ----------------------
# Habe die absoluten pfade dazugefuegt, weil sonst findet dieser script die 
# dateien nicht, wenn er nicht gerade von richtigen direktorie gestartet wird.
#
#
# ----------------------
# Letzte Aenderung 8.9.01:
# ----------------------
# Funktiniert alles.
#
#
# ----------------------
# Letzte Aenderung 2.1.01 :
# ----------------------
# 1.-> MUSS NOCH DOPPELTE ZEILEN FILTRIEREN!! - erledigt
# 2.-> WAS passiert wenn z.B. die zeile mit Ausgeliehen fehlt?????
#
#
# ---------------------
# Letzte Aenderung 2.1.01 :
# ---------------------
# Vertig.
#
#
# ---------------------
# Letzte Aenderung 1.1.01 :
# ---------------------
# Funktioniert fast alles bis auf, dass Authoren und Editoren sind noch nicht
# ausseinander genommen. Die muessen aufgespalltet werden, in dem der ";" 
# enfernt wird.
#
# ---------------------------
# Letzte Aenderung 31.12.00
# ---------------------------
# Umwandlung von daten der db in mpi-bib-format!
# Beschreibung:
#
#   Die aktuellen daten der coli-bib werden in mpi-format umgewandelt
#   und an mpi verschickt.
#
#   Eingabe - muss eine ausgelesene tabelle aus der db sein.
#   Ausgabe - ist in mpi format mit % zeichen vorne
#
#
#  Was schon gemacht ist:
#  - gibt fast alles richtig aus bis auf die authoren
#
###############################################################################
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#


#------------------------------------------------------------------------------
# --> 0.1 <--   hier wird space vor jeder zeile eingefuegt
#  
#             
#------------------------------------------------------------------------------
#use FileHandle;


open (read_out,"/home/SG/dainius/fopra/db-2-mpi/books_db.txt") 
  || die "cannot open file for reading: $!";

open (write_in,">/home/SG/dainius/fopra/db-2-mpi/a")
  || die "cannot open file for writing: $!";


@leer = ("% ");



while (<read_out>)
  {
    @zeile = $_;
    @zeile = (@leer,@zeile);

    
print write_in "@zeile"; 
  }

close(read_out) || die "can't close  books_db.txt : $!";
close(write_in) || die "can't close  a ";

#------------------------------------------------------------------------------
# --> 1. <--   hier werden statt "\t" die "%" zeichen eingefuegt
#  
#             
#------------------------------------------------------------------------------

open (read_out,"/home/SG/dainius/fopra/db-2-mpi/a")
  || die "cannot open file for reading: $!";

open (write_in,">/home/SG/dainius/fopra/db-2-mpi/b")
  || die "cannot open file for writing: $!";


while (<read_out>)
  {
   # $eingabe = $_;

    s/\t/%/g; # alle      \t  -> %
  #  s/\s/%/;  # der erste \s  -> %
    

    
print write_in "$_" ; 
  }

#---------------------------------------------------------------------
# --> 2 <-- Ersetze % mit \n%
#-------------------------------------------------------------------

open (read_out,"/home/SG/dainius/fopra/db-2-mpi/b")
  || die "cannot open file for reading: $!";
open (write_in,">/home/SG/dainius/fopra/db-2-mpi/c")
  || die "cannot open file for writing: $!";
#@komma=(",");
#chomp($_);
while (<read_out>)
  {
    
    s/%/\n% /g;  # ersetze  % -> "\n% "
    
    print write_in "$_"; 

  }
#---------------------------------------------------------------------
# --> 2.1 <-- Ersetze 0 und 1 mit Verfuegbar
#-------------------------------------------------------------------

open (read_out,"/home/SG/dainius/fopra/db-2-mpi/c")
  || die "cannot open file for reading: $!";
open (write_in,">/home/SG/dainius/fopra/db-2-mpi/d")
  || die "cannot open file for writing: $!";
#@komma=(",");
#chomp($_);
while (<read_out>)
  {

    s/% 0\n/% Verf\\\"ugbar\n/g;
    s/% 1\n/% Verf\\\"ugbar\n/g;
    
    print write_in "$_"; 
  }

#---------------------------------------------------------------------
# --> 2.2 <-- Ersetze datum von ausgeliehen mit Ausgeliehen
#-------------------------------------------------------------------

open (read_out,"/home/SG/dainius/fopra/db-2-mpi/d")
  || die "cannot open file for reading: $!";
open (write_in,">/home/SG/dainius/fopra/db-2-mpi/e")
  || die "cannot open file for writing: $!";
#@komma=(",");
#chomp($_);
while (<read_out>)
  {
   # $eingabe = $_;

    
    
    
    
    s/% 200.-..-..\n/% Ausgeliehen\n/g;


    #s/\s/%/;
    
print write_in "$_"; 
  }

#---------------------------------------------------------------------
# --> 2.3 <-- Reserve!!
#-------------------------------------------------------------------

open (read_out,"/home/SG/dainius/fopra/db-2-mpi/e")
  || die "cannot open file for reading: $!";
open (write_in,">/home/SG/dainius/fopra/db-2-mpi/f")
  || die "cannot open file for writing: $!";
#@komma=(",");
#chomp($_);
while (<read_out>)
  {
    
    print write_in "$_"; 
    
  }

#---------------------------------------------------------------------
# --> 3 <-- Fuege die Buchstaben nach der Reihenfolge ein!
#-------------------------------------------------------------------

open (read_out,"/home/SG/dainius/fopra/db-2-mpi/f")
  || die "cannot open file for reading: $!";
open (write_in,">/home/SG/dainius/fopra/db-2-mpi/g")
  || die "cannot open file for writing: $!";

@Reihe = qw(A E T X D K S c I C W O H Z Y);





$i = 0;
while (<read_out>)
  {
    
    if ( chomp($_) eq /%/) # geht bis zu der ersten leeren zeile 
      {

	s/%/%$Reihe[$i]/;
	$i++;

      }
    else 
      {
	$i = 0;
      }
    
    print write_in "$_\n"; 
  }

#---------------------------------------------------------------------
# --> 4 <-- Ersetze die ";" durch "\n" und "%A"
#-------------------------------------------------------------------

open (read_out,"/home/SG/dainius/fopra/db-2-mpi/g")
  || die "cannot open file for reading: $!";
open (write_in,">/home/SG/dainius/fopra/db-2-mpi/h")
  || die "cannot open file for writing: $!";

while (<read_out>)
  { 
    if ( chomp($_) eq /%A/ && /;/ )
      {
	s/;/\n%A /g;
      }
    
    print write_in "$_\n";
    
  }
#---------------------------------------------------------------------
# --> 5 <-- Ersetze die ";" durch "\n" und "%E"
#-------------------------------------------------------------------

open (read_out,"/home/SG/dainius/fopra/db-2-mpi/h")
  || die "cannot open file for reading: $!";
open (write_in,">/home/SG/dainius/fopra/db-2-mpi/i")
  || die "cannot open file for writing: $!";

while (<read_out>)
  { 
    if ( chomp($_) eq /%E/ && /;/ )
      {
	s/;/\n%E /g;
      }
    
    print write_in "$_\n";
    
  }

#---------------------------------------------------------------------
# --> 6 <-- (i)   Fuege den leerzeichen zwischen Namen und Vornamen.
#           (ii) Mache alle doppelten spaces weg.
#-------------------------------------------------------------------

open (read_out,"/home/SG/dainius/fopra/db-2-mpi/i")
  || die "cannot open file for reading: $!";
open (write_in,">/home/SG/dainius/fopra/db-2-mpi/j")
  || die "cannot open file for writing: $!";

while (<read_out>)
  { 

    	s/,/, /g;
	s/\s+/ /g;    

    print write_in "$_\n";
    
  }



#--------------------------------------------------------------------------
# --> 7 <-- (i)Mache alle leeren zeilen weg
#           (ii) mache alle leeren zeilen weg, die am anfang "space" haben.
#---------------------------------------------------------------------------

open (read_out,"/home/SG/dainius/fopra/db-2-mpi/j")
  || die "cannot open file for reading: $!";
open (write_in,">/home/SG/dainius/fopra/db-2-mpi/k")
  || die "cannot open file for writing: $!";

while (<read_out>)
{ 
      
	s/%\w\s\n//; #(i)
  	s/^ //;      #(ii)
      
    print write_in "$_";
  
}

#---------------------------------------------------------------------
# --> 8 <-- Konvertiere alle umlaute in \"a und die erste leere zeile weg!
#-------------------------------------------------------------------

open (read_out,"/home/SG/dainius/fopra/db-2-mpi/k")
  || die "cannot open file for reading: $!";
open (write_in,">/home/SG/dainius/fopra/db-2-mpi/books.kat")
  || die "cannot open file for writing: $!";

while (<read_out>)
  { 
    
    s//\\\"a/g;
    s//\\\"A/g;
    
    s//\\\"o/g;
    s//\\\"O/g;

    s//\\\"u/g;
    s//\\\"U/g;

    s//\\\"s/g;  
         
        
    print write_in "$_";
  
  }

 




# Ein paar dateien werden enfernt
unlink qw(/home/SG/dainius/fopra/db-2-mpi/a /home/SG/dainius/fopra/db-2-mpi/b /home/SG/dainius/fopra/db-2-mpi/c /home/SG/dainius/fopra/db-2-mpi/d /home/SG/dainius/fopra/db-2-mpi/e /home/SG/dainius/fopra/db-2-mpi/f /home/SG/dainius/fopra/db-2-mpi/g /home/SG/dainius/fopra/db-2-mpi/h /home/SG/dainius/fopra/db-2-mpi/i /home/SG/dainius/fopra/db-2-mpi/j /home/SG/dainius/fopra/db-2-mpi/k /home/SG/dainius/fopra/db-2-mpi/l);
