<?


////////////////////////////////////////////////////////
//
// correcting_book_text.php3 - Correcting mistakes in CoLi Database
//                             all correcting fields are text fields
//                             no scroll-up menu
//   
//
////////////////////////////////////////////////////////
//
// Last Modified : 20.03.02
// Korrektur wird so gemacht:
//  --> 1 <-- Die erste Seite wird aufgerufen. 
//            Dort kann man die Signatur eingeben.
//
//  --> 2 <-- Dann suche ich nach books.id und books_exemplar.id!
//            Standart und formular ausgabe. Hier kann man schon die 
//            eintraege korrigieren. Die obere standart ausgabe dient 
//            dazu, dass man nachschauen kann was man zu korrigieren hat.
//
//  --> 3 <-- Nach den 'id's wird spaeter korrigiert! 
//            Ausgabe der standart ausgabe 
//            (also tabelle, ohne moeglichkeit zu korriegieren). 
// 
// 
//
// ---------------------------------------------------- 
// Correcting books in CoLi
//
// Author: Dainius Ramanauskas 
// Last Modified : 31.12.00
//
// See the file: bib_standard.inc,
//
// Functions :
// ===========
//   1. first_page()   
//   2. display_results()      
//   3. insert_records()       
//
////////////////////////////////////////////////////////

// include file
include ("/home/SG/dainius/php/bib_standard.inc");

define ( FIRST,0);
define ( SECOND,1);
define ( THIRD,3);


//-----------------------------------------------------------------------------
// Anfang der Funktionen
//-----------------------------------------------------------------------------


//---------------------------------------------------------
//
// --> 1 <-- Erste Seite wird aufgerufen, 
//           wo man die den suchbegriff eingeben kann
//
//-----------------------------------------------------------

function first_page ()
{
  global $PHP_SELF;
  
  printf ("<FORM method=\"post\" ACTION=\"%s?action=%d\">\n",$PHP_SELF, SECOND);
  
  print ("<br><center><h1> Korrektur der B&uuml;cher </h1></center>");
  
  print ("<table align=center>");
  print (" <tr><td> <select name=In_where>   "
	 ."           <option> -- SIGNATUR vom BUCH! -- "
	 ."         </select>                "
	 ." <input type=text  name=\"Find\"  ");  // $Find  
  // "Find" wird als globale variable definiert
  // "name = In_where ist" ist nicht mehr wichtig, da es so wieso nur
  // nach signatur gesucht wird.

  print ( " value=\"\" size=15></td>       ");
  print ( "    <tr><td align=center>       "
	  ."   <input  type=\"submit\"     "
	  ."   value=\"Suchen\"></td>\n    ");
  print ("<BR>\n");
  print ("</table>");
  
  print ("</form>\n");
  
}

// ----------------------------------------------------------
//
// --> 2 <-- Die Resultate werden ausgegeben!!!!!!!!
//
// ----------------------------------------------------------

function display_results () {
  global $PHP_SELF;
  global $Find;   
  
  
  
  
  
  //
  // Suche nach 
  //             books_exemplar.Id
  //             books_exemplar.books_id  . 
  // Beide sind eindeutig!!
  //
  $query  = "select                                        "
     ."         books_exemplar.id,                            "
     ."         books_exemplar.books_id                      "
     ."      from                                            "
     ."         books_exemplar                               "
     ."      where                                           "
     ."                  books_exemplar.coli_id = \"$Find\"  " ;
     
  
  // Uberpruefe, ob der query richtig ist:
  $result = mysql_query($query)
     or die ("can't execute query 2.1");
  
  // Versuche zu fetchen, d.h. es wird array erzeugt, auf den dann mit 
  // $row[0] oder $row[1] zugegriffen wird:

   if (!($row = mysql_fetch_row($result)))
	{
	  print("errno:" . mysql_errno());
	  print("error:" . mysql_error());
	  echo " <BR> 2.2 geht nicht <BR>";
	}
  
  // Hier werden die ID's nummer festgehalten!
  $books_exemplar_id = $row[0];
  $books_id =          $row[1];



  
  
  // hier wird gesucht nach:
  //       SIGNATUR!!
  
  $query  = "select                                          "
     ."         books.*,                                     "
     ."         books_exemplar.coli_id,                      "
     ."         books_exemplar.bib_location,                 "
     ."         books_exemplar.borrowed,                     "
     ."         books_exemplar.id                            "
     ."      from                                            "
     ."         books,                                       "
     ."         books_exemplar                               "
     ."      where                                           "
     ."         (                                            "
     ."                  books.id = \"$books_id\"            "
     ."            AND                                       "
     ."                  books_exemplar.id = \"$books_exemplar_id\" "
     ."         ) ";
  
  
  // wird nachgeschaut, ob der query ok ist:
  $result = mysql_query($query)
     or die ("can't execute query 1");
  
  // header fuer html-ausgabe:
  echo (" <caption><h1><center>Suchergebnis f&#252;r $Find : "
	."       </center></h1></caption>                    ");
  
  // hier werden rekursiv die daten ausgegeben:
  while ($row = mysql_fetch_row($result)) {
    
    // wird nachgeschaut, ob buch ausgeliehen ist oder nicht.
    // wenn 0 dann --> vorhanden, wenn 1 dann ausgeliehen
    $num_from_table=$row[16];
    $is_num=0;
    if ($num_from_table==$is_num)
      {
	$print_to="Vorhanden";  // wird Vorhanden ausgegeben
      }
    else 
      {
	$print_to="Ausgeliehen bis $row[16]"; // wird das datum ausgegeben
      }
      
    // hier wird die tabelle ausgegeben
    echo ("<table align=center border=0 width=70%>");
    //echo ("<colgroup>");
    //  echo ("<col width=100>");
    //  echo ("<col width=300>");
    //echo ("</colgroup>");
      
    printf ("<tr bgcolor=#f1f49c >
                <td width=100> Books.Id    </td> 
                 <td width=300>           &nbsp;%s  </td>
                 </tr>\n", $row[0]);

    // Hier wird die Id von Book.Id festgehalten, um spaeter korrekturen
    // vorzunehmen. Siehe unten.
    //    $Books_Id = $row[0];
    
    printf ("<tr bgcolor=#f1f49c >
                 <td width=100 > Author </td> 
                 <td width=300>&nbsp;%s</td>
              </tr>\n", $row[1]);
      
    printf ("<tr bgcolor=#f1f49c>
                 <td width=100> Editor </td> 
                 <td width=300> &nbsp; %s   </td> 
              </tr>", $row[2]);
    
    printf ("<tr bgcolor=#d6f98a >
               <td width=100><strong> Titel </strong> </td> 
               <td width=300><strong> &nbsp;%s  </strong>   </td>
            </tr>\n", $row[3]);
    
    printf ("<tr bgcolor=#f1f49c >
               <td width=100 > Typ </td> 
               <td width=300>&nbsp;%s       </td>
            </tr>\n", $row[4]);
    
    printf ("<tr bgcolor=#f1f49c >
                <td width=100 > Jahr </td> 
                <td width=300> &nbsp;%s       </td>
            </tr>\n", $row[5]);

    printf ("<tr bgcolor=#f1f49c >
                <td  width=100> Schl&uuml;sselwort </td> 
                <td width=300> &nbsp;%s                     </td>
            </tr>\n", $row[6]);
    printf ("<tr bgcolor=#f1f49c >
                <td width=100 > Series </td> 
                <td width=300> &nbsp;%s         </td>
            </tr>\n", $row[7]);

    printf ("<tr bgcolor=#f1f49c >
                <td width=100 > K&ouml;rperschaft </td> 
                <td width=300> &nbsp;%s                   </td>
            </tr>\n", $row[8]);

    printf ("<tr bgcolor=#f1f49c >
                <td width=100 > Verlag  </td> 
                <td width=300> &nbsp;%s          </td>
            </tr>\n", $row[9]);

    printf ("<tr bgcolor=#f1f49c >
                <td width=100 > Verlags Ort </td> 
                <td width=300> &nbsp;%s              </td>
            </tr>\n", $row[10]);

    printf ("<tr bgcolor=#f1f49c >
                <td width=100 > Bibliothek </td> 
                <td width=300> &nbsp;%s            </td>
            </tr>\n", $row[11]);

    printf ("<tr bgcolor=#f1f49c >
                <td width=100 > ISBN </td> 
                <td width=300> &nbsp;%s       </td>
            </tr>\n", $row[12]);

    printf ("<tr bgcolor=#ddddff >
                <td width=100 > Standort in Bib </td> 
                <td width=300> &nbsp;%s                  </td>
            </tr>\n", $row[15]);

    printf ("<tr bgcolor=#ddddff >
                <td width=100 >Auth Abk. </td> 
                <td width=300> &nbsp;%s          </td>
            </tr>\n", $row[13]);

    printf ("<tr bgcolor=#ddddff >
                <td width=100 >Signatur </td> 
                <td width=300> &nbsp;%s          </td>
            </tr>\n", $row[14]);

    printf ("<tr bgcolor=#cccccc >
                <td width=100 > Status </td> 
                <td width=300> &nbsp;%s              </td>
            </tr>\n", $print_to);

    printf ("<tr bgcolor=#999666 >
                <td width=100 > Books_exemplar.id </td> 
                <td width=300> &nbsp;%s              </td>
            </tr>\n", $row[17]);
     
    // Hier wird die globale Variable fuer Books_exemplar.id definiert.
    // Die bruacht man um in Tabelle Books.exemplar zu korrigieren. 
    // Es koennen ja mehrere exemplare auftreten. Es werden immer
    // die gleichen stamm dateien angezeigt, aber nicht die gleichen 
    // exemplar dateien. 
    //    $Books_Exemplar_Id = $row[16];


    echo ("</table><p><p><p>");
    

    //-----------------------------------------------
    // --> 2.2 <-- Die Tabelle zu korrektur wird ausgegeben
    //----------------------------------------------
    
    
    
    
    // Definiere Datum 
    $year_now = date("Y");
    
    
    printf ("<FORM  method=\"post\" ACTION=\"%s?action=%d\">\n",
	    $PHP_SELF,THIRD);
    
    
    printf ("<table>");
    printf (" <tr><td>Buch_Id &nbsp;</td> 
           <td> <select name=Books_Id>
           <option> $row[0]
           </select>
           </td>");
    
    //    printf (" <tr ><td bgcolor=red>Buch_Id&nbsp; NICHT KORRIGIREN </td> 
    //     <td> <input type=text  name=Books_Id
    //                    value=\"$row[0]\" size=255 maxlength=255 readonly></td>");  
 

    printf (" <tr><td>Verfasser ( NACHNAME, VORNAME; NACHN, VORN; )&nbsp;</td> 
           <td> <input type=text  name=Author
                          value=\"$row[1]\" size=255 maxlength=255></td>");  
 
 
    printf (" <tr><td>Editor &nbsp;</td> 
           <td> <input type=text  name=Editor
                           value=\"$row[2]\" size=225 maxlength=255></td>");

printf (" <tr><td>Titel &nbsp;</td> 
           <td> <input type=text  name=Title
                           value=\"$row[3]\"size=255 maxlength=255></td>");


printf (" <tr><td>Typ &nbsp;</td> 
           <td> <input type=text  name=Typ
                value=\"$row[4]\"size=50 maxlength=50></td>");
 
           
           

printf (" <tr> <td>Jahrgang&nbsp;</td> 
           <td> <input type=text  name=Year_a
                value=\"$row[5]\" size=4 maxlength=4></td>");
 
printf (" <tr><td>Schl&uuml;&szlig;el Wort&nbsp;</td> 
           <td> <input type=text  name=Keyword
                   value=\"$row[6]\" size=255 maxlength=255></td>");

printf (" <tr><td>Serie &nbsp;</td> 
           <td> <input type=text  name=Series
                   value=\"$row[7]\" size=50 maxlength=255></td>");

printf (" <tr><td>K&ouml;rperschaft&nbsp;</td> 
           <td> <input type=text  name=Corporation
                   value=\"$row[8]\" size=50 maxlength=255></td>");

printf (" <tr><td>Verlag &nbsp;</td> 
           <td> <input type=text  name=Publisher
                   value=\"$row[9]\" size=50 maxlength=50></td>");

printf (" <tr><td>Verlags Ort &nbsp;</td> 
           <td> <input type=text  name=Publisher_location
                 value=\"$row[10]\"  size=50 maxlength=50></td>");

printf (" <tr><td>Bibliothek &nbsp;</td> 
           <td> <input type=text  name=Bib
                   value=\"$row[11]\"size=20 maxlength=20></td>");

printf (" <tr><td>ISBN &nbsp;</td> 
           <td> <input type=text  name=Isbn
                  value=\"$row[12]\" size=20 maxlength=20></td>");



printf (" <tr><td>Standort &nbsp;</td> 
           <td> <input type=text name=Bib_location
                  value=\"$row[15]\" size=20 maxlength=20></td>");



printf (" <tr><td>Buch Abk. &nbsp;</td> 
         <td> <input type=text  name=A_short
               value=\"$row[13]\" size=30 maxlength=30></td>");

printf (" <tr><td>Signatur &nbsp;</td> 
           <td> <input type=text  name=Coli_id
                 value=\"$row[14]\" size=30 maxlength=30></td>");



//printf (" <tr><td>Standort &nbsp;</td> 
//           <td> <input type=text name=Bib_location
//                 value=\"$row[15]\" size=30 maxlength=30></td>");

printf (" <tr><td>Status &nbsp;</td> 
           <td> <input type=text name=Status
                 value=\"$print_to\" size=30 maxlength=30></td>");

//printf (" <tr><td bgcolor=red>Books_Exemplar_Id &nbsp NICHT KORRIGIEREN;</td> 
//         <td> <input type=text name=Books_Exemplar_Id
//               value=\"$row[16]\" size=30 maxlength=30 readonly></td>");

printf (" <tr><td>Books_Exemplar_Id &nbsp;</td> 
           <td> <select name=Books_Exemplar_Id>
           <option> $row[17]
           </select>
           </td>");

 
 printf ("<tr><td><input  type=submit  value=Korrigieren></td>\n");
 printf ("<BR>\n");
 printf ("</table>");
 
 printf ("</form>\n");

 

 

   } 
 
 
}




//-----------------------------------------------------------------------------
// --> 3 <-- Korrigierte Daten werden zuruecke geschrieben !! VORSICHTIG!
//
//           ES WERDEN ALLE DATEN NEU IN DIE DATENBANK REINGESCHRIEBEN !
//
//-----------------------------------------------------------------------------

function insert_records () {
  global $PHP_SELF;
  global
    $Books_Exemplar_Id,     // ist die Id von books_exemplar!
    $Books_Id,              // ist die Id von books!! 
    $Author,
    $Editor,
    $Title,
    $Typ,
    $Year_a,
    $Keyword,
    $Series,
    $Corporation,
    $Publisher,
    $Publisher_location,
    $Bib,
    $Isbn,
    $Coli_id,
    $A_short,
    $Bib_location,
    $Status;

  /*
  printf ("--> $Books_Exemplar_Id<BR>");
  printf ("--> $Books_Id <BR>");
  printf ("--> $Author <BR>");
  printf ("--> $Editor <BR>");
  printf ("--> $Title <BR>");
  printf ("--> $Typ   <BR>");
  printf ("--> $Year_a <BR>");
  printf ("--> $Keyword <BR>");
  printf ("--> $Series <BR>");
  printf ("--> $Corporation <BR>");
  printf ("--> $Publisher <BR>");
  printf ("--> $Publisher_location <BR>");
  printf ("--> $Bib <BR>");
  printf ("--> $Isbn <BR>");
  printf ("--> $Coli_id <BR>");
  printf ("--> $Bib_location <BR>");
  printf ("--> $Status <BR>");
  */
  
  // definiere array
  $array_for_global  =array(
			    $Books_Id,        // Wird nicht benutzt -- 0--
			    $Author,                         // -- 1 --
			    $Editor,                         // -- 2 --
			    $Title,                          // -- 3 --
			    $Typ,                            // -- 4 --
			    $Year_a,                         // -- 5 --
			    $Keyword,                        // -- 6 --
			    $Series,                         // -- 7 --
			    $Corporation,                    // -- 8 --
			    $Publisher,                      // -- 9 --
			    $Publisher_location,             // -- 10 --
			    $Bib,                            // -- 11 --
			    $Isbn,                           // -- 12 --
			    $A_short,                         // -- 13 -- !!
			    $Coli_id,                        // -- 14 --
			    $Bib_location,                   // -- 15 --
			    $Status);                        // -- 16 --
  
  $list_table_names = array (
			     "books_id",                        // -- 0 --
			     "author",                       // -- 1 --
			     "editor",                       // -- 2 --
			     "title",                        // -- 3 --
			     "typ",                          // -- 4 --
			     "year_a",                       // -- 5 --
			     "keyword",                      // -- 6 --
			     "series",                       // -- 7 --
			     "corporation",                  // -- 8 --
			     "publisher",                    // -- 9 --
			     "publisher_location",           // -- 10 --
			     "bib",                          // -- 11 --
			     "isbn",                         // -- 12 --
			     "short_auth",                   // -- 13 -- !!             
			     "coli_id",                      // -- 14 --
			     "bib_location",                 // -- 15 --
			     "borrowed");                    // -- 16 --
    
  
  // ersetze die werte in der BOOKS tabelle! 
  // Benutze die $Books_Id !!


      
      
      //echo "$Books_Id<BR>";
      
      for ($i = 1;$i<=13;$i++)
	{
	  
	  $query1="update books "
	     . "   set $list_table_names[$i] = '$array_for_global[$i]'"
	     . "   where id='$Books_Id'                                 ";
	  
	  // nachfrage ob alles glatt gegangen ist?
	  if (!($result = mysql_query($query1)))
	    {
	      print("errno:" . mysql_errno());
	      print("error:" . mysql_error());
	      echo "Books korrektur fehlgeschlagen<BR>";
	    }
	  
	}
      
      //
      // ersetze werte in der BOOKS_EXEMPLAR  tabelle !!
      // nur 'signatur' und 'bib_location' !!
      //
      // Benutze $Books_Exemplar_Id !!
      //
      
      //echo "$Books_Exemplar_Id";
      
      for ($i = 14; $i<=15; $i++)
	{
	  $query2 = " update books_exemplar "
	     ."       set $list_table_names[$i] = '$array_for_global[$i]' "
	     ."       where books_exemplar.id = '$Books_Exemplar_Id'                ";
	  
       // nachfrage ob alles glatt gegangen ist?
	  if (!($result = mysql_query($query2)))
	    {
	      print("errno:" . mysql_errno());
	      print("error:" . mysql_error());
	      echo "Books_exemplar korrektur fehlgeschlagen<BR>";
	    }
	}
      
      
      //
      // DIE TABELLE WIRD NOCH MAL AUSGEGEBEN
      // Hier verwende ich noch mal $Books_Exemplar_Id, um den Exemplar
      // Eindeutig auszugeben.
      //

      $query  = "select                                          "
	 ."         books.*,                                     "
	 ."         books_exemplar.coli_id,                      "
	 ."         books_exemplar.bib_location,                 "
	 ."         books_exemplar.borrowed                      "
	 ."      from                                            "
	 ."         books,                                       "
	 ."         books_exemplar                               "
	 ."      where                                           "
	 ."         (                                            "
	 ."                  books_exemplar.id ='$Books_Exemplar_Id'       "
	 ."            AND                                       "
	 ."                  books.id = books_exemplar.books_id  "
	 ."         ) ";
      
      
      
      $result = mysql_query($query)
	 or die ("can't execute query 2");
      
      echo (" <caption><h1><center>Richtig Korrigiert ??? : "
	    ."       </center></h1></caption>                    ");
  
      
      while ($row = mysql_fetch_row($result)) {
	
	// wird nachgeschaut, ob buch ausgeliehen ist oder nicht.
	// wenn 0 dann --> vorhanden, wenn 1 dann ausgeliehen
	$num_from_table=$row[16];
	$is_num=0;
	if ($num_from_table==$is_num)
	  {
	    $print_to="Vorhanden";  // wird Vorhanden ausgegeben
	  }
	else 
	  {
	    $print_to="Ausgeliehen bis $row[16]"; // wird das datum ausgegeben
	  }
	
	// hier wird die tabelle ausgegeben
	echo ("<table align=center border=0 width=70%>");
	//echo ("<colgroup>");
	//  echo ("<col width=100>");
	//  echo ("<col width=300>");
	//echo ("</colgroup>");
	
	printf ("<tr bgcolor=#f1f49c >
<td width=100> Id    </td> 
<td width=300>           &nbsp;%s  </td>
</tr>\n", $row[0]);
	
	// !!
	//     $Find1 = $row[0];
	
	printf ("<tr bgcolor=#f1f49c >
<td width=100 > Author </td> 
<td width=300>&nbsp;%s</td>
</tr>\n", $row[1]);
	
	printf ("<tr bgcolor=#f1f49c>
<td width=100> Editor </td> 
<td width=300> &nbsp; %s   </td> 
</tr>", $row[2]);
	
	printf ("<tr bgcolor=#d6f98a >
<td width=100><strong> Titel </strong> </td> 
<td width=300><strong> &nbsp;%s  </strong>   </td>
</tr>\n", $row[3]);
	
	printf ("<tr bgcolor=#f1f49c >
<td width=100 > Typ </td> 
<td width=300>&nbsp;%s       </td>
</tr>\n", $row[4]);
    
	printf ("<tr bgcolor=#f1f49c >
<td width=100 > Jahr </td> 
<td width=300> &nbsp;%s       </td>
</tr>\n", $row[5]);
	
	printf ("<tr bgcolor=#f1f49c >
<td  width=100> Schl&uuml;sselwort </td> 
<td width=300> &nbsp;%s                     </td>
</tr>\n", $row[6]);
    
	printf ("<tr bgcolor=#f1f49c >
<td width=100 > Series </td> 
<td width=300> &nbsp;%s         </td>
</tr>\n", $row[7]);
    
	printf ("<tr bgcolor=#f1f49c >
<td width=100 > K&ouml;rperschaft </td> 
<td width=300> &nbsp;%s                   </td>
</tr>\n", $row[8]);
	
	printf ("<tr bgcolor=#f1f49c >
<td width=100 > Verlag  </td> 
<td width=300> &nbsp;%s          </td>
</tr>\n", $row[9]);
    
	printf ("<tr bgcolor=#f1f49c >
<td width=100 > Verlags Ort </td> 
<td width=300> &nbsp;%s              </td>
</tr>\n", $row[10]);
	
	printf ("<tr bgcolor=#f1f49c >
<td width=100 > Bibliothek </td> 
<td width=300> &nbsp;%s            </td>
</tr>\n", $row[11]);
     
    
	printf ("<tr bgcolor=#f1f49c >
<td width=100 > ISBN </td> 
<td width=300> &nbsp;%s       </td>
</tr>\n", $row[12]);
  	
	printf ("<tr bgcolor=#ddddff >
<td width=100 > Standort in Bib </td> 
<td width=300> &nbsp;%s                  </td>
</tr>\n", $row[15]);

   	printf ("<tr bgcolor=#ddddff >
<td width=100 >Author Abk. </td> 
<td width=300> &nbsp;%s          </td>
</tr>\n", $row[13]);
   
	printf ("<tr bgcolor=#ddddff >
<td width=100 >Signatur </td> 
<td width=300> &nbsp;%s          </td>
</tr>\n", $row[14]);
    

      

	printf ("<tr bgcolor=#cccccc >
<td width=100 > Status </td> 
<td width=300> &nbsp;%s              </td>
</tr>\n", $print_to);
	
	
	
	echo ("</table><p><p><p>");
      }
    }

 
 // -- ENDE DER INSERT_RECORD --

//
// Ende der Funktionen 
// ====================
//
/////////////////////////////////////////////////////////////////////////////// 

$titel = " Bibliothek Computerlinguistik ";
$color = "black";
html_begin($titel,$titel,$color);
link_to_main_page ();
bib_adm_connect()
     or die ("can't connect to server");

if (empty($action))
     $action = FIRST;
     
switch ($action)
{
 case FIRST:
   first_page ();
   break;
 case SECOND:
   display_results ();
   break;
 case THIRD:
   insert_records ();
   break;

 default:
   die("unknown action code ($action)");
}
link_to_main_page ();
html_end ();
?>
